package com.leanplum.sample;

import com.leanplum.Leanplum;
import com.leanplum.LeanplumApplication;
import com.leanplum.LeanplumPushService;
import com.leanplum.Var;
import com.leanplum.annotations.Variable;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class MyApp extends LeanplumApplication {
  /**
   * Unused, but shows you how to create a list variable.
   */
  @Variable
  public static List<Double> prices = Arrays.asList(0.99, 1.99, 2.99, 4.99);

  /**
   * Title of the heading.
   */
  @Variable(name = "Text.Welcome Text")
  public static String title = "Welcome to Leanplum!";

  /**
   * Text of main screen.
   */
  @Variable(group = "Text")
  public static String mainText = "Hello, world!";

  /**
   * URL pointing to the Leanplum Tree app.
   */
  @Variable
  public static String MARKET_URL = "market://details?id=com.leanplum.leanplumtree";

  /**
   * Whether the promo can be tapped.
   */
  @Variable
  public static boolean promoTouchEnabled = true;

  /**
   * Promo asset.
   */
  static Var<String> promo;

  @Override
  public void onCreate() {
    super.onCreate();
    if (BuildConfig.DEBUG) {
      Leanplum.setAppIdForDevelopmentMode(
          [INSERT APP ID HERE],
      [INSERT DEVELOPMENT KEY HERE]);
    } else {
      Leanplum.setAppIdForProductionMode(
          [INSERT APP ID HERE],
      [INSERT PRODUCTION KEY HERE]);
    }

    // (Advanced). Uncomment to use the provided open-source templates rather than the templates
    // built into the SDK. Use this if you are modifying the existing templates.
    // MessageTemplates.register(getApplicationContext());

    // This optional line prints out a lot of stuff to the
    // console, so you can see how Leanplum works.
    // Note that in development mode, events don't get batched, so that
    // it's easier to test analytics in realtime. Event batching
    // happens in production.
    Leanplum.enableVerboseLoggingInDevelopmentMode();

    // Syncs all layout files and starts Leanplum.
    promo = Var.defineAsset("Promo Image", "promo_green.png");
    Leanplum.syncResources(Collections.singletonList("layout/.*"), null);

    LeanplumPushService.setGcmSenderId(LeanplumPushService.LEANPLUM_SENDER_ID);

    Leanplum.start(this);
  }
}
